package Table;

import java.util.ArrayList;

/**
 * This class needs to manage an ArrayList of Entry objects.  It needs a get method that takes a key and returns
 * its corresponding value, or null of the key is not in the arraylist.  It needs a put method that takes a key and value
 * and makes an entry with key, value.  NOTE: There cannot be two entries with the same key.
 * It also needs a remove method which takes a key and, if that key exists in the arraylist, removes that item.
 * Void return on `remove`.
 */
public class Table<K, V> {
    private ArrayList<Entry> entries;

    public Table() {
        this.entries = new ArrayList<>();
    }

    public V get(K k){
        V value = null;
        for(Entry e: entries){
            if(e.getKey().equals(k)){
                value = (V)e.getValue();
            }
        }
        return value;
    }

    public void put(K k, V v){
        Entry newEntry = new Entry(k,v);
        if(entries.contains(newEntry.getKey())) {
            for (Entry e : entries) {
                if (e.getKey().equals(k)) {
                    e.setValue(v);
                }
            }
        } else entries.add(newEntry);
    }

    public void remove(K k){
        int removeIndex = -1;
        for (Entry e: entries) {
            if(k.equals(e.getKey())){
                removeIndex = entries.indexOf(e);
            }
        }
        entries.remove(removeIndex);
    }
}
