package TableNested;

import Table.Entry;

import java.util.ArrayList;

/**
 * All you need to do for this microlab is take the Table and Entry from the last one and make Entry a nested class.
 * Think about how nested classes should work with generics.
 */
public class TableNested<K, V> {
    ArrayList<Entry> entries;

    public TableNested(){
        this.entries = new ArrayList<Entry>();
    }

    private class Entry<K, V> {
        private K key;
        private V value;

        public Entry(K key, V value) {
            this.key = key;
            this.value = value;
        }

        public K getKey() {
            return key;
        }

        public V getValue() {
            return value;
        }

        public void setKey(K key) {
            this.key = key;
        }

        public void setValue(V value) {
            this.value = value;
        }
    }

    public V get(K k) {
        V value = null;
        for(Entry e: entries){
            if(e.getKey().equals(k)){
                value = (V)e.getValue();
            }
        }
        return value;
    }

    public void put(K k, V v) {
        Entry newEntry = new Entry(k,v);
        if(entries.contains(newEntry.getKey())) {
            for (Entry e : entries) {
                if (e.getKey().equals(k)) {
                    e.setValue(v);
                }
            }
        } else entries.add(newEntry);
    }

    public void remove(K k) {

        int removeIndex = -1;
        for (Entry e: entries) {
            if(k.equals(e.getKey())){
                removeIndex = entries.indexOf(e);
            }
        }
        entries.remove(removeIndex);
    }
}

